/*
 * MosP - Mind Open Source Project         http://www.mosp.jp/
 * Copyright (C) 1987-2009 MIND Co., Ltd.  http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.system.action;

import java.util.ArrayList;
import java.util.List;


import jp.mosp.common.CommonConst;
import jp.mosp.common.MosPAction;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.common.MospUtility;
import jp.mosp.common.part.PartManager;

import jp.mosp.system.dao.MCodeDao;
import jp.mosp.system.dto.MCodeDto;
import jp.mosp.system.vo.YukyuInformationCardVo;

public class YukyuInformationCardAction extends MosPAction {

	//コマンド
	private static final String CMD_YUKYU_INFO_SHOW 		= "S2700";	//表示
	private static final String CMD_YUKYU_INFO_UPDATE		= "S2708";	//更新

	/**
	 * コンストラクタ
	 */
	public YukyuInformationCardAction() {
		super();
	}

	/**
	 * アクション
	 */
	public void action() throws Exception {
		// DBコネクション取得
		getConnection();
		// システム権限確認
		confirmSystemAuth();
		// VOの取得及び設定
		YukyuInformationCardVo vo = new YukyuInformationCardVo();
		vo.initVo(cfg, msg, cmd, aspUser, user);
		vo.setParams(request);
		// VO及びフォワード先の準備
		setVo(vo);
		setUrl(vo.getRetUrl());
		// プルダウンリスト作成
		vo.aryPltCFKbn = getPltCFKbnArray();
		vo.aryPltCFMonth = util.getMonthArray();
		// コマンド毎の処理
		if (cmd.equals(CMD_YUKYU_INFO_SHOW)) {
			// 表示
			show(vo);
		} else if (cmd.equals(CMD_YUKYU_INFO_UPDATE)){
			// 繰越更新、条件更新
			regist(vo);
			// コミット
			commit();			
			// 表示
			show(vo);
			// メッセージ設定
			vo.setMessage(MospUtility.getMessage(msg, MospConst.MSG_UPDATE, ""));
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}

	/**
	 * 設定項目検索
	 * @param vo Voインスタンス
	 * @throws Exception
	 */
	private void show(YukyuInformationCardVo vo) throws Exception {
		// 有給繰越情報 
		String[] aryPaidHolidayInfo = getPaidHolidayInfo();
		// 繰越月
		vo.setPltCFMonth(aryPaidHolidayInfo[0]);
		// 繰越日数
		vo.setTxtCFDays(aryPaidHolidayInfo[1]);
		// 繰越区分
		vo.setPltCFKbn(aryPaidHolidayInfo[2]);
		// 有給休暇支給	
		vo.setDefaultValues();
		vo.setFields(PartManager.mospcode(partInfo()).getPaidHolidayList());		
		// モード設定
		vo.setMode(YukyuInformationCardVo.MODE_UPDATE);		
	}

	/**
	 * データ更新（繰越項目）
	 * @param vo 対象VO
	 * @param dto 対象DTO
	 * @throws Exception
	 */
	private void regist(YukyuInformationCardVo vo) throws Exception {
		// パラメータの妥当性確認
		vo.validate();
		// DTOの準備
		MCodeDto dto = new MCodeDto(); 
		dto.setTId(CommonConst.NAM_PAID_HOLIDAY);
		// 繰越月
		vo.setDtoFieldsCFMonth(dto);
		update(vo, dto);
		// 繰越日数
		vo.setDtoFieldsCFDay(dto);
		update(vo, dto);
		// 繰越区分
		vo.setDtoFieldsCFDivision(dto);	
		update(vo, dto);
		// データ更新(支給条件)
		update(vo);
	}

	/**
	 * データ更新（繰越条件）
	 * @param vo
	 * @param dto
	 * @throws Exception
	 */
	private void update(YukyuInformationCardVo vo, MCodeDto dto) throws Exception {
		// DAOの準備
		MCodeDao dao = new MCodeDao();
		dao.initDao(cfg, cmd, aspUser, user, conn);
		// DTOの再取得
		MCodeDto retDto;
		// 排他確認
		chkExclusive(dao.findForKey(dto.getTId(), dto.getTCode()), dao.findForUpdate(dto.getTId(), dto.getTCode()), vo);
		// データの更新
		dao.update(dto);
		// アップデートのチェック
		retDto = dao.findForKey(dto.getTId(), dto.getTCode());
		chkUpdate(retDto);
	}

	/**
	 * データ更新(支給条件)
	 * @param vo 対象VO
	 * @throws Exception
	 */
	private void update(YukyuInformationCardVo vo) throws Exception {
		// DAOの準備
		MCodeDao dao = new MCodeDao();
		dao.initDao(cfg, cmd, aspUser, user, conn);
		// 更新前準備
		// テーブルロック
		dao.tableLock(CommonConst.NAM_PAID_HOLIDAY + CommonConst.NAM_SUPPLY);
		// 削除
		dao.delete(CommonConst.NAM_PAID_HOLIDAY + CommonConst.NAM_SUPPLY);	
		// DTOの準備
		List<MCodeDto> listCode = new ArrayList<MCodeDto>(20);
		vo.setDtoFields(listCode);
		for (int i = 0; i < listCode.size(); i++) {
			MCodeDto dto = listCode.get(i);
			if (dto.getTCode().equals("")) {
				continue;
			}
			// 重複確認
			chkDuplicate(dao.findForKey(dto.getTId(), dto.getTCode()), vo);
			// 登録
			dao.insert(dto);
			// DTOの再取得
			chkInsert(dao.findForKey(dto.getTId(), dto.getTCode()));
		}
	}

	/**
	 * 繰越区分
	 * @return 繰越区分配列
	 */
	private String[][] getPltCFKbnArray() {
		// 配列の作成
		String[][] aryPosition = new String[2][2];
		for (int i = 0; i < aryPosition.length; i++) {
			if (i == 0) {
				aryPosition[i][0] = String.valueOf(i);
				aryPosition[i][1] = CommonConst.NAM_CARRY_OVER_THIS_YEAR;
			} else {
				aryPosition[i][0] =  String.valueOf(i);
				aryPosition[i][1] = CommonConst.NAM_CARRY_OVER_TOTAL;
			}
		}
		return aryPosition;
	}

}
